// ──────────────────────────────
// プログラム3-1a　測距モジュールによる距離の測定
// ──────────────────────────────
#include <LiquidCrystal.h>	// ライブラリの読み込み《LiquidCrystal.h》 1
#define PBS1 9			// 置き換え（PBS1 → "9"）
#define analogPin 0		// 置き換え（analogPin → "0"）
int threshold = 80;		// int 型変数「threshold」に80 を代入 2
int value = 0;			// 変数「value」はint 型，value をクリア（0）
LiquidCrystal lcd(12,11,10,5,4,3,2);	// LiquidCrystal 型の変数「lcd」をつくる 3
void setup()			// 初期設定
{
  pinMode(PBS1,INPUT);		// PBS1（ピン9）を入力に設定
  lcd.begin(2,16);		// LCD の表示行数と桁数を指定（16 文字× 2 行）
}
void loop()			// メインの処理
{
  int s1 = digitalRead(PBS1);	// PBS1 の値を読み取り，s1 に代入（s1 はint 型）
  if(s1 == LOW)			// s1 がLOW（PBS1 がON）ならば，次へ行く
  {
    while(1)			// ループ〈1〉
    {
      lcd.clear();		// LCD の画面をクリアし，カーソルを左上の角に移動
      value = analogRead(analogPin);	// A-D 変換，デジタル値をvalue に代入
      lcd.setCursor(1,0);	// カーソルを「1 列，0 行」にセットする，1 列：左端の次，0 行：1 行目
      lcd.print("Distance= ");	//“ Distance= ”を表示
      if(value > threshold)	// この条件が成立すれば，次へ行く 4
      {
        int range = (6787/(value-3))-4;	// デジタル値「value」を距離に変換し，range に代入
        lcd.print(range);	//“ Distance= ”の右横にrangeの値を表示
        lcd.print(" cm");	// 続けて右横に“ cm”を表示
      }
      else			// 測距範囲内に物体がない場合
        lcd.print("OFF");	// 　　　┗━━“ Distance= ”の右横に“OFF”を表示
      delay(500);		// タイマ（0.5s）
    }
  }
}

