// ──────────────────────────────
// プログラム3-1b　シリアル通信 測距モジュールによる距離の測定
// ──────────────────────────────
#define analogPin 0		// 置き換え（analogPin → "0"）
#define PBS1 9			// 置き換え（PBS1 → "9"）
int threshold = 80;		// int 型変数「threshold」に80 を代入
int value = 0;			// 変数「value」はint 型，value をクリア（0）
int range = 0;			// 変数「range 」はint 型，range をクリア（0）
void setup()			// 初期設定
{
  Serial.begin(9600);		// シリアル通信のデータ転送レートをbps（baud）で指定
  pinMode(PBS1,INPUT);		// PBS1（ピン9）を入力に設定
}
void loop()			// メインの処理
{
  int s1 = digitalRead(PBS1);	// PBS1 の値を読み取り，s1 に代入（s1 はint 型）
  if(s1 == LOW)			// s1 がLOW（PBS1 がON）ならば，次へ行く
  {
    value = analogRead(analogPin);	// A-D 変換，デジタル値をvalue に代入
    Serial.print("Distance= ");	// シリアル端末に“Distance= ”を表示
    if(value > threshold)	// この条件が成立すれば，次へ行く
    {
      range = (6787/(value-3))-4;	// デジタル値「value」を距離に変換し，range に代入
      Serial.print(range);	//“ Distance= ”の右横にrangeの値を表示
      Serial.println(" cm");	// 続けて右横に“ cm”を表示し，改行する
    }
    else			// 測距範囲内に物体がない場合
      Serial.println("OFF");	// 　┗━━“ Distance= ”の右横に“OFF”を表示し，改行する
    delay(300);			// タイマ（0.3s）
  }
}

