// ──────────────────────────────
// プログラム3-2a　圧力レベル表示器
// ──────────────────────────────
#include <LiquidCrystal.h>	// ライブラリの読み込み《LiquidCrystal.h》
#define PBS1 0			// 置き換え（PBS1 → "0"）
#define analogPin 0		// 置き換え（analogPin → "0"）
LiquidCrystal lcd(9,8,7,13,12,11,10);	// LiquidCrystal 型の変数「lcd」をつくる 1
void setup()			// 初期設定
{
  pinMode(PBS1,INPUT);		// PBS1（ピン0）を入力に設定
  DDRD = B11111110;		// DDRD はポートD の方向レジスタで，各ピンの入出力を設定（1：出力／ 0：入力） 2
  lcd.begin(2,16);		// LCD の表示行数と桁数を指定（16 文字× 2 行）
}
void loop()			// メインの処理
{
  int s1 = digitalRead(PBS1);	// PBS1 の値を読み取り，s1 に代入（s1 はint 型）
  if(s1 == LOW)			// s1 がLOW（PBS1 がON）ならば，次へ行く
  {
    while(1)			// ループ〈1〉
    {
      lcd.clear();		// LCD の画面をクリアし，カーソルを左上の角に移動
      int value = 0;		// 変数「value」はint 型，value をクリア（0）
      PORTD = 0;		// PORTD はクリア（0）
      value = analogRead(analogPin);	// A-D 変換，デジタル値をvalue に代入
      lcd.setCursor(0,0);	// カーソルを「0 列，0 行」にセットする，0 列：左端／ 0 行：1 行目
      lcd.print("Pressure= ");	//“ Pressure= ”を表示
      lcd.print(value);		//“ Pressure= ”の右横にvalueの値を表示
      if(value >= 200)		// value ≧ 200 ならば，次へ行く
        digitalWrite(2,HIGH);	// ピン2 に"HIGH" を出力（LED1 点灯）
      if(value >= 400)		// value ≧ 400 ならば，次へ行く
      {
        digitalWrite(2,HIGH);	// ピン2 に"HIGH" を出力（LED1 点灯）
        digitalWrite(3,HIGH);	// ピン3 に"HIGH" を出力（LED2 点灯）
      }
      if(value >= 600)		// value ≧ 600 ならば，次へ行く
      {
        digitalWrite(2,HIGH);	// ピン2 に"HIGH" を出力（LED1 点灯）
        digitalWrite(3,HIGH);	// ピン3 に"HIGH" を出力（LED2 点灯）
        digitalWrite(4,HIGH);	// ピン4 に"HIGH" を出力（LED3 点灯）
      }
      if(value >= 800)		// value ≧ 800 ならば，次へ行く
      {
        digitalWrite(2,HIGH);	// ピン2 に"HIGH" を出力（LED1 点灯）
        digitalWrite(3,HIGH);	// ピン3 に"HIGH" を出力（LED2 点灯）
        digitalWrite(4,HIGH);	// ピン4 に"HIGH" を出力（LED3 点灯）
        digitalWrite(5,HIGH);	// ピン5 に"HIGH" を出力（LED4 点灯）
      }
      if(value >= 900)		// value ≧ 900 ならば，次へ行く
      {
        digitalWrite(2,HIGH);	// ピン2 に"HIGH" を出力（LED1 点灯）
        digitalWrite(3,HIGH);	// ピン3 に"HIGH" を出力（LED2 点灯）
        digitalWrite(4,HIGH);	// ピン4 に"HIGH" を出力（LED3 点灯）
        digitalWrite(5,HIGH);	// ピン5 に"HIGH" を出力（LED4 点灯）
        digitalWrite(6,HIGH);	// ピン6 に"HIGH" を出力（LED5 点灯）
      }
      delay(1000);		// タイマ（1s）
    }
  }
}

