// ──────────────────────────────
// プログラム4-1a　7 セグメントLED 2 桁表示の温度計
// ──────────────────────────────
#define PBS1 12			// 置き換え（PBS1 → "12"）
#define analogPin 0		// 置き換え（analogPin → "0"）
int v1, v2, value, s1, count;	// 変数「v1，v2，value，s1，count」はint 型
int STROBE = 0x02;		// 変数「STROBE」はint 型，STROBE に0x02 を代入
float temperature;		// 変数「temperature」はfloat 型（浮動小数点型）
void setup()			// 初期設定
{
  DDRD = B01111111;		// ポートD の入出力を設定 1
  DDRB = B001111;		// ポートB の入出力を設定 2
}
void loop()			// メインの処理
{
  int arrangement_data[] = {0x7e, 0x30, 0x6d, 0x79, 0x33,
                        0x5b, 0x1f, 0x72, 0x7f, 0x73};		// 配列に表示データを代入，int 型
  s1 = digitalRead(PBS1);	// PBS1 の値を読み取り，s1 に代入
  if(s1 == LOW)			// s1がLOW（PBS1 がON）ならば，次へ行く
  {
    while(1)			// ループ〈1〉
    {
      value = analogRead(analogPin);	// A-D 変換，デジタル値をvalue に代入
      temperature = (5.0000*value/1023)*100;	// 温度の計算式
      temperature = temperature+0.500;	// 温度の補正
      while(1)			// ループ〈2〉
      {
        v2 = temperature/10;	// 表示器2 桁目の計算 3
        v1 = temperature-v2*10;	// 表示器1 桁目の計算
        if( (STROBE <<= 1) == 0x04 )	// 左シフト .
        {
          STROBE = 0x01;	// STROBEに0x01を代入
          PORTD = arrangement_data[v1];	// 配列のデータv1 をPORTD に出力
          PORTB = B001100;	// 1桁目表示，B001100 →ピン[8,9]は 0（LOW）
          delay(5);		// タイマ（5ms）
          PORTB = B001111;	// 1桁目，2 桁目ともに表示なし，B001111→ピン[8～11] は1（HIGH）
          delay(1);		// タイマ（1ms）
        }
        if(STROBE == 0x02)	// STROBEの値が0x02になったら次へ行く
        {
          PORTD = arrangement_data[v2];	// 配列のデータv2 をPORTD に出力
          PORTB = B000011;	// 2 桁目表示，B000011→ピン[10,11]は 0（LOW）
          delay(5);		// タイマ（5ms）
          PORTB = B001111;	// 1桁目，2桁目ともに表示なし
          delay(1);		// タイマ（1ms）
        }
        count++;		// count のインクリメント（＋1） .
        if(count == 50)		// countの値が50になったら次へ行く
        {
          count = 0;		// count のクリア（0）
          break;		// break文でループ〈2〉を脱出
        }
      }
    }
  }
}

