// ──────────────────────────────
// プログラム4-2a　液晶表示器（LCD）を使用した温度計
// ──────────────────────────────
#include <LiquidCrystal.h>	// ライブラリの読み込み《LiquidCrystal.h》
#define PBS1 9			// 置き換え（PBS1 → "9"）
LiquidCrystal lcd(12,11,10,5,4,3,2);	// LiquidCrystal 型の変数「lcd」をつくる 1
int analogPin = 0;		// 変数「analogPin」はint 型，analogPin をクリア（0）
int value = 0;			// 変数「value」はint 型，value をクリア（0）
int Max = 0;			// 変数「Max」はint 型，Max をクリア（0）
int Min = 1023;			// 変数「Min」はint 型，Min に1023 を代入
float Ondo = 0;			// 変数「Ondo」はfloat 型（浮動小数点型），Ondo をクリア（0）
float Maxondo = 0;		// 変数「Maxondo」はfloat 型（浮動小数点型），Maxondo をクリア（0）
float Minondo = 0;		// 変数「Minondo」はfloat 型（浮動小数点型），Minondo をクリア（0）
void setup()			// 初期設定
{
  pinMode(PBS1,INPUT);		// PBS1（ピン9）を入力に設定
  lcd.begin(2,16);		// LCD の表示行数と桁数を指定（16 文字× 2 行）
}
void loop()			// メインの処理
{
  int s1 = digitalRead(PBS1);	// PBS1 の値を読み取り，s1 に代入（s1 はint 型）
  if(s1 == LOW)			// s1 がLOW（PBS1 がON）ならば，次へ行く
  {
    while(1)			// ループ〈1〉
    {
      value = analogRead(analogPin);	// A-D 変換，デジタル値をvalue に代入
      if(value > Max)		// value＞Maxならば，
        Max = value;		// 　┗━━ Max にvalue を代入（常にvalue の最大値を記憶）
      if(value < Min)		// value＜Minならば，
        Min = value;		// 　┗━━ Min にvalue を代入（常にvalue の最小値を記憶）
      Ondo = value/20.00;	// 浮動小数点演算（value の値を321 とすると，321/20 ＝16.05 がOndo に代入される）
      Maxondo = Max / 20.00;	// 最大値の計算
      Minondo = Min / 20.00;	// 最小値の計算
      lcd.setCursor(0,0);	// カーソルを「0 列，0 行」にセット，0 列：左端／ 0 行：1 行目
      lcd.print("Ondo= ");	//“ Ondo= ”を表示
      lcd.setCursor(6,0);	// カーソルを「6 列，0 行」にセット
      lcd.print(Ondo);		// Ondoの値を表示
      lcd.setCursor(12,0);	// カーソルを「12 列，0 行」にセット
      lcd.print("do c");	//“ do c”を表示
      lcd.setCursor(0,1);	// カーソルを「0 列，1 行」にセット
      lcd.print(Maxondo);	// Maxondoの値を表示
      lcd.setCursor(9,1);	// カーソルを「9 列，1 行」にセット
      lcd.print(Minondo);	// Minondoの値を表示
    }
  }
}

