// ──────────────────────────────
// プログラム5-2a　RC サーボの制御（1）
// ──────────────────────────────
#include <Servo.h>		// ライブラリの読み込み《Servo.h》
#define PBS1 10			// 置き換え（PBS1 → "10"）
#define PBS2 11			// 置き換え（PBS2 → "11"）
#define analogPin 0		// 置き換え（analogPin → "0"）
Servo RCservo1;			// Servo型の変数は「RCservo1」にする
void setup()			// 初期設定
{
  RCservo1.attach(7);		// サーボ変数「RCservo1」をピン7に割り当てる
  pinMode(PBS1,INPUT);		// PBS1（ピン10）を入力に設定
  pinMode(PBS2,INPUT);		// PBS2（ピン11）を入力に設定
}
void loop()			// メインの処理
{
  int s1 = digitalRead(PBS1);	// PBS1 の値を読み取り，s1 に代入（s1 はint 型）
  if(s1 == LOW)			// s1がLOW（PBS1 がON）ならば，次へ行く
  {
    while(1)			// ループ〈1〉
    {
      int value = analogRead(analogPin);	// A-D 変換，デジタル値をvalue（int 型）に代入
      int degree = map(value,0,1023,0,180);	// map 関数による数値の変換 1
      RCservo1.write(degree);	// サーボ出力（degree は角度） 2
      int s2 = digitalRead(PBS2);	// PBS2 の値を読み取り，s2 に代入（s2 はint 型）
      if(s2 == LOW)		// s2がLOW（PBS2 がON）ならば，次へ行く
      {
        RCservo1.write(90);	// サーボ出力（角度は90°）
        break;			// break文でループ〈1〉を脱出
      }
    }
  }
}

