// ──────────────────────────────
// プログラム6-2a　二足歩行ロボットの製作
// ──────────────────────────────
#include <Servo.h>		// ライブラリの読み込み《Servo.h》
#define PBS1 8			// 置き換え（PBS1 → "8"）
#define PBS2 9			// 置き換え（PBS2 → "9"）
#define analogPin 0		// 置き換え（analogPin → "0"）
int value = 0;			// 変数「value」はint 型，value をクリア（0）
Servo servo0, servo1, servo2, servo3;	// Servo 型の変数は「servo0」～「servo3」にする
void back();			// プロトタイピング，関数の型式を事前に宣言する（戻り値なし）
void left();			// プロトタイピング（戻り値なし）
void setup()			// 初期設定
{
  servo0.attach(2);		// サーボ変数「servo0」をピン2 に割り当てる（RC サーボ0）
  servo1.attach(3);		// サーボ変数「servo1」をピン3 に割り当てる（RC サーボ1）
  servo2.attach(4);		// サーボ変数「servo2」をピン4 に割り当てる（RC サーボ2）
  servo3.attach(5);		// サーボ変数「servo3」をピン5 に割り当てる（RC サーボ3）
  pinMode(PBS1,INPUT);		// PBS1（ピン8）を入力に設定
  pinMode(PBS2,INPUT);		// PBS2（ピン9）を入力に設定
}
void loop()			// メインの処理
{
  int s1 = digitalRead(PBS1);	// PBS1 の値を読み取り，s1 に代入（s1 はint 型）
  if(s1 == LOW)			// s1がLOW（PBS1 がON）ならば，次へ行く
  {
    while(1)			// ループ〈1〉
    {
      while(1)			// ループ〈2〉
      {
        while(1)		// ループ〈3〉
        {
          servo0.write(108);	// サーボ出力，servo0 の角度は108°，90°を基準にすると（＋18°）
          servo1.write(132);	// サーボ出力，servo1 の角度は132°（＋ 42°），左足に重心
          value = analogRead(analogPin);	// A-D 変換，デジタル値をvalue に代入
          if(value >= 460)	// value ≧ 460 ならば，　　　　　　　　 1
            break;		// 　┗━━ break 文でループ〈3〉を脱出
            delay(300);		// タイマ（0.3s）
          servo2.write(118);	// サーボ出力，servo2 の角度は118°（＋28°）
          servo3.write(118);	// サーボ出力，servo3 の角度は118°（＋28°），右足を前
            delay(300);		// タイマ（0.3s）
          servo0.write(48);	// サーボ出力，servo0 の角度は48°（－ 42°）
          servo1.write(72);	// サーボ出力，servo1 の角度は72°（－18°），右足に重心
          value = analogRead(analogPin);	// A-D 変換，デジタル値をvalue に代入
          if(value >= 460)	// value≧460ならば，
            break;		// 　┗━━ break 文でループ〈3〉を脱出
            delay(300);		// タイマ（0.3s）
          servo2.write(62);	// サーボ出力，servo2 の角度は62°（－28°）
          servo3.write(62);	// サーボ出力，servo3 の角度は62°（－28°），左足を前
            delay(300);		// タイマ（0.3s）
        }
        if(value >= 460)	// value≧460ならば，次へ行く
        {
          back(); back(); back(); back(); back();	// 関数back を呼び出す（後進動作）
          left(); left(); left(); left(); left();	// 関数left を呼び出す（左方向への旋回動作）
          break;		// break文でループ〈2〉を脱出
        }
      }
    }
  }
  int s2 = digitalRead(PBS2);	// PBS2 の値を読み取り，s2 に代入（s2 はint 型）
  if(s2 == LOW)			// s2がLOW（PBS2 がON）ならば，次へ行く
  {
    while(1)			// ループ〈4〉（ここからパフォーマンス動作）
    {
      servo0.write(56);
      servo1.write(123);
        delay(500);
      servo2.write(61);
      servo3.write(61);
        delay(500);
      servo0.write(115);
      servo1.write(90);
        delay(500);
      servo2.write(118);
      servo3.write(118);
        delay(500);
      servo0.write(107);
      servo1.write(135);
        delay(500);
      servo2.write(61);
      servo3.write(61);
        delay(500);
      servo0.write(78);
      servo1.write(45);
        delay(500);
      servo2.write(45);
      servo3.write(45);
        delay(500);
      servo0.write(78);
      servo1.write(45);
        delay(1000);
      servo2.write(135);
      servo3.write(135);
        delay(500);
      servo0.write(146);
      servo1.write(90);
        delay(500);
      servo2.write(118);
      servo3.write(118);
        delay(500);
      servo0.write(118);
      servo1.write(61);
        delay(500);
      servo2.write(61);
      servo3.write(61);
        delay(500);
      servo0.write(56);
      servo1.write(123);
        delay(500);
      servo2.write(140);
      servo3.write(140);
        delay(500);
    }
  }
}
void back()			// 関数backの本体（後進動作）
{
  servo0.write(48);
  servo1.write(72);
    delay(300);
  servo2.write(118);
  servo3.write(118);
    delay(300);
  servo0.write(108);
  servo1.write(132);
    delay(300);
  servo2.write(62);
  servo3.write(62);
    delay(300);
}
void left()			// 関数leftの本体（左方向への旋回動作）
{
  servo0.write(108);
  servo1.write(132);
    delay(300);
  servo2.write(130);
  servo3.write(100);
    delay(300);
  servo0.write(48);
  servo1.write(73);
    delay(300);
  servo2.write(62);
  servo3.write(62);
    delay(300);
}

